# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ResourcesManagement::Mgmt::V2018_03_01_preview
  module Models
    #
    # Management group creation parameters.
    #
    class CreateManagementGroupRequest

      include MsRestAzure

      # @return [String] The fully qualified ID for the management group.  For
      # example,
      # /providers/Microsoft.Management/managementGroups/0000000-0000-0000-0000-000000000000
      attr_accessor :id

      # @return [String] The type of the resource.  For example,
      # /providers/Microsoft.Management/managementGroups
      attr_accessor :type

      # @return [String] The name of the management group. For example,
      # 00000000-0000-0000-0000-000000000000
      attr_accessor :name

      # @return [String] The AAD Tenant ID associated with the management
      # group. For example, 00000000-0000-0000-0000-000000000000
      attr_accessor :tenant_id

      # @return [String] The friendly name of the management group. If no value
      # is passed then this  field will be set to the groupId.
      attr_accessor :display_name

      # @return [Array<String>] The roles definitions associated with the
      # management group.
      attr_accessor :roles

      # @return [CreateManagementGroupDetails] Details.
      attr_accessor :details

      # @return [Array<CreateManagementGroupChildInfo>] The list of children.
      attr_accessor :children


      #
      # Mapper for CreateManagementGroupRequest class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'CreateManagementGroupRequest',
          type: {
            name: 'Composite',
            class_name: 'CreateManagementGroupRequest',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              tenant_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.tenantId',
                type: {
                  name: 'String'
                }
              },
              display_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.displayName',
                type: {
                  name: 'String'
                }
              },
              roles: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.roles',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              details: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.details',
                type: {
                  name: 'Composite',
                  class_name: 'CreateManagementGroupDetails'
                }
              },
              children: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.children',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'CreateManagementGroupChildInfoElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'CreateManagementGroupChildInfo'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
